<?php
/**
 * Custom page walker for this theme.
 *
 * @package Modern Art Gallery
 */

if (!class_exists('Modern_Art_Gallery_Walker_Page')) {
    /**
     * CUSTOM PAGE WALKER
     * A custom walker for pages.
     */
    class Modern_Art_Gallery_Walker_Page extends Walker_Page
    {

        /**
         * Outputs the beginning of the current element in the tree.
         *
         * @param string $modern_art_gallery_output Used to append additional content. Passed by reference.
         * @param WP_Post $page Page data object.
         * @param int $modern_art_gallery_depth Optional. Depth of page. Used for padding. Default 0.
         * @param array $modern_art_gallery_args Optional. Array of arguments. Default empty array.
         * @param int $current_page Optional. Page ID. Default 0.
         * @since 2.1.0
         *
         * @see Walker::start_el()
         */

        public function start_lvl( &$modern_art_gallery_output, $modern_art_gallery_depth = 0, $modern_art_gallery_args = array() ) {
            $modern_art_gallery_indent  = str_repeat( "\t", $modern_art_gallery_depth );
            $modern_art_gallery_output .= "$modern_art_gallery_indent<ul class='sub-menu'>\n";
        }

        public function start_el(&$modern_art_gallery_output, $page, $modern_art_gallery_depth = 0, $modern_art_gallery_args = array(), $current_page = 0)
        {

            if (isset($modern_art_gallery_args['item_spacing']) && 'preserve' === $modern_art_gallery_args['item_spacing']) {
                $t = "\t";
                $n = "\n";
            } else {
                $t = '';
                $n = '';
            }
            if ($modern_art_gallery_depth) {
                $modern_art_gallery_indent = str_repeat($t, $modern_art_gallery_depth);
            } else {
                $modern_art_gallery_indent = '';
            }

            $modern_art_gallery_css_class = array('page_item', 'page-item-' . $page->ID);

            if (isset($modern_art_gallery_args['pages_with_children'][$page->ID])) {
                $modern_art_gallery_css_class[] = 'page_item_has_children';
            }

            if (!empty($current_page)) {
                $_current_page = get_post($current_page);
                if ($_current_page && in_array($page->ID, $_current_page->ancestors, true)) {
                    $modern_art_gallery_css_class[] = 'current_page_ancestor';
                }
                if ($page->ID === $current_page) {
                    $modern_art_gallery_css_class[] = 'current_page_item';
                } elseif ($_current_page && $page->ID === $_current_page->post_parent) {
                    $modern_art_gallery_css_class[] = 'current_page_parent';
                }
            } elseif (get_option('page_for_posts') === $page->ID) {
                $modern_art_gallery_css_class[] = 'current_page_parent';
            }

            /** This filter is documented in wp-includes/class-walker-page.php */
            $modern_art_gallery_css_classes = implode(' ', apply_filters('page_css_class', $modern_art_gallery_css_class, $page, $modern_art_gallery_depth, $modern_art_gallery_args, $current_page));
            $modern_art_gallery_css_classes = $modern_art_gallery_css_classes ? ' class="' . esc_attr($modern_art_gallery_css_classes) . '"' : '';

            if ('' === $page->post_title) {
                /* translators: %d: ID of a post. */
                $page->post_title = sprintf(__('#%d (no title)', 'modern-art-gallery'), $page->ID);
            }

            $modern_art_gallery_args['link_before'] = empty($modern_art_gallery_args['link_before']) ? '' : $modern_art_gallery_args['link_before'];
            $modern_art_gallery_args['link_after'] = empty($modern_art_gallery_args['link_after']) ? '' : $modern_art_gallery_args['link_after'];

            $modern_art_gallery_atts = array();
            $modern_art_gallery_atts['href'] = get_permalink($page->ID);
            $modern_art_gallery_atts['aria-current'] = ($page->ID === $current_page) ? 'page' : '';

            /** This filter is documented in wp-includes/class-walker-page.php */
            $modern_art_gallery_atts = apply_filters('page_menu_link_attributes', $modern_art_gallery_atts, $page, $modern_art_gallery_depth, $modern_art_gallery_args, $current_page);

            $modern_art_gallery_attributes = '';
            foreach ($modern_art_gallery_atts as $attr => $modern_art_gallery_value) {
                if (!empty($modern_art_gallery_value)) {
                    $modern_art_gallery_value = ('href' === $attr) ? esc_url($modern_art_gallery_value) : esc_attr($modern_art_gallery_value);
                    $modern_art_gallery_attributes .= ' ' . $attr . '="' . $modern_art_gallery_value . '"';
                }
            }

            $modern_art_gallery_args['list_item_before'] = '';
            $modern_art_gallery_args['list_item_after'] = '';
            $modern_art_gallery_args['icon_rennder'] = '';
            // Wrap the link in a div and append a sub menu toggle.
            if (isset($modern_art_gallery_args['show_toggles']) && true === $modern_art_gallery_args['show_toggles']) {
                // Wrap the menu item link contents in a div, used for positioning.
                $modern_art_gallery_args['list_item_after'] = '';
            }


            // Add icons to menu items with children.
            if (isset($modern_art_gallery_args['show_sub_menu_icons']) && true === $modern_art_gallery_args['show_sub_menu_icons']) {
                if (isset($modern_art_gallery_args['pages_with_children'][$page->ID])) {
                    $modern_art_gallery_args['icon_rennder'] = '';
                }
            }

            // Add icons to menu items with children.
            if (isset($modern_art_gallery_args['show_toggles']) && true === $modern_art_gallery_args['show_toggles']) {
                if (isset($modern_art_gallery_args['pages_with_children'][$page->ID])) {

                    $toggle_target_string = '.page_item.page-item-' . $page->ID . ' > .sub-menu';

                    $modern_art_gallery_args['list_item_after'] = '<button type="button" class="theme-aria-button submenu-toggle" data-toggle-target="' . $toggle_target_string . '" data-toggle-type="slidetoggle" data-toggle-duration="250"><span class="btn__content" tabindex="-1"><span class="screen-reader-text">' . __( 'Show sub menu', 'modern-art-gallery' ) . '</span>' . modern_art_gallery_get_theme_svg( 'chevron-down' ) . '</span></button>';
                }
            }

            if (isset($modern_art_gallery_args['show_toggles']) && true === $modern_art_gallery_args['show_toggles']) {

                $modern_art_gallery_output .= $modern_art_gallery_indent . sprintf(
                        '<li%s>%s%s<a%s>%s%s%s</a>%s%s',
                        $modern_art_gallery_css_classes,
                        '<div class="submenu-wrapper">',
                        $modern_art_gallery_args['list_item_before'],
                        $modern_art_gallery_attributes,
                        $modern_art_gallery_args['link_before'],
                        /** This filter is documented in wp-includes/post-template.php */
                        apply_filters('the_title', $page->post_title, $page->ID),
                        $modern_art_gallery_args['link_after'],
                        $modern_art_gallery_args['list_item_after'],
                        '</div>'
                    );

            }else{

                $modern_art_gallery_output .= $modern_art_gallery_indent . sprintf(
                        '<li%s>%s<a%s>%s%s%s%s</a>%s',
                        $modern_art_gallery_css_classes,
                        $modern_art_gallery_args['list_item_before'],
                        $modern_art_gallery_attributes,
                        $modern_art_gallery_args['link_before'],
                        /** This filter is documented in wp-includes/post-template.php */
                        apply_filters('the_title', $page->post_title, $page->ID),
                        $modern_art_gallery_args['icon_rennder'],
                        $modern_art_gallery_args['link_after'],
                        $modern_art_gallery_args['list_item_after']
                    );

            }

            if (!empty($modern_art_gallery_args['show_date'])) {
                if ('modified' === $modern_art_gallery_args['show_date']) {
                    $modern_art_gallery_time = $page->post_modified;
                } else {
                    $modern_art_gallery_time = $page->post_date;
                }

                $modern_art_gallery_date_format = empty($modern_art_gallery_args['date_format']) ? '' : $modern_art_gallery_args['date_format'];
                $modern_art_gallery_output .= ' ' . mysql2date($modern_art_gallery_date_format, $modern_art_gallery_time);
            }
        }
    }
}